package de.hsrg.gui;

import java.awt.Container;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JSlider;
import javax.swing.event.ChangeListener;

public class Dashboard extends GridBagLayout {
	private static final long serialVersionUID = 7261768809561438958L;
	final static String START = "Start", STOP = "Stop", 
					    RESET = "Reset", QUIT = "Quit";
	private GridBagConstraints constraints;
	private JButton starter, reset, quit;		
	private Container content;
	private JSlider velocity;  
	private BlueCube cube;	
	
	public Dashboard( Container content, BlueCube cube,
			         ActionListener controller, ChangeListener adjuster )  {
		velocity = new JSlider(0, BlueCube.MAX_VELOCITY, BlueCube.DEFAULT_VELOCITY);		
		this.content = content;  this.cube = cube;
		constraints = new GridBagConstraints( );	
		starter = new JButton(START);
		starter.addActionListener(controller);
		reset = new JButton(RESET);
		reset.addActionListener(controller);
		quit = new JButton(QUIT);
		quit.addActionListener(controller);		
		velocity.addChangeListener(adjuster);		
	}

	public void setup() {
		content.setLayout(this);
    	constraints.fill = GridBagConstraints.BOTH;
    	constraints.gridx = 0;  constraints.gridy = 0;
    	constraints.weightx = 1.0; constraints.weighty = 0.6;           
        content.add(cube, constraints);
    	constraints.gridx = 0;  constraints.gridy = 1;
    	constraints.weighty = 0.1;
        content.add(velocity, constraints);
        constraints.gridy = 2;
        content.add(starter, constraints);
        constraints.gridy = 3;
        content.add(reset, constraints);
        constraints.gridy = 4;
        content.add(quit, constraints);       
	}

	public int getVelocity() {
		return velocity.getValue( );
	}

}
